﻿/* This code is restricted under LGPL license */
namespace infoMECHANICA.NHibernateORM.CriteriaBuilder
{
    /// <summary>
    /// Interface of objects which can create subcriterias (detached criteria which
    /// are related with different object)
    /// </summary>
    public interface ISubcriteriaSource : ICriteriaSource
    {
        /// <summary>
        /// Type of subquery criteria conjunction
        /// </summary>
        SubqueryConjunctionTypes SubqueryConjuntionType { get; }        

        /// <summary>
        /// The name of master's object referenced property (the name of property which can create 
        /// conjunction between subqueries)
        /// </summary>
        string MasterPropertyName { get; }
    }
}
