﻿/* This code is restricted under LGPL license */
using System;

namespace infoMECHANICA.NHibernateORM.CriteriaBuilder
{
    /// <summary>
    /// Exception singnals that recorder instance have been created already, and it shouldn't be overriden!
    /// </summary>
    public class RecorderAlreadyCreatedException : Exception
    {
        private const string defaultMessage = 
            "Recorder instance have been created already, and it shouldn't be overriden!";
        
        /// <summary>
        /// Default constructor
        /// </summary>
        public RecorderAlreadyCreatedException() : this(defaultMessage)
        {
        }

        /// <summary>
        /// Recommended constructor (sets exception message)
        /// </summary>
        /// <param name="message">Message to set</param>
        public RecorderAlreadyCreatedException(string message)
            : base(message)
        {
        }
    }
}
